require 'uri'
require 'cgi'
require 'net/http'
require 'active_support'
require 'active_support/core_ext/object'

require 'mocloud/utils'
require 'mocloud/api'

module Mocloud
module Commands

	class Login
		def description
			"Log in to Mobingi"
		end

		def run
			opts = Trollop::options do
				banner <<-ENDOFHELP
Usage: mobingi login [options]"

Login to your Mobingi account. You need to login to be able to create, delete, inspect and modify your stacks.
				ENDOFHELP

				opt :endpoint, "Set API Endpoint", :default => "api.mobingi.com"
			end

			print "Username (email): "
			username = STDIN.gets.chomp
			password = Mocloud::Utils.get_password
			puts ""

			api = Mocloud::API.new
			res = api.get_unauthed(opts[:endpoint], "/v1/login", :username => username, :password => password)

			Mocloud::Utils.handle_error(res, "Login failed")

			puts "Successfully logged in!"

			creds = Mocloud::Utils::Credentials.new

			userinfo = JSON.parse(res[:body])
			userinfo["username"] = username
			userinfo["endpoint"] = opts[:endpoint]

			creds.write_credentials(userinfo)

		end
	end

end
end