Gem.find_files("mocloud/utils/*.rb").each { |path| require path }

module Mocloud
module Utils

	if STDIN.respond_to?(:noecho)
	  def Utils.get_password(prompt="Password: ")
	    print prompt
	    STDIN.noecho(&:gets).chomp
	  end
	else
	  def Utils.get_password(prompt="Password: ")
	    `read -s -p "#{prompt}" password; echo $password`.chomp
	  end
	end

	def Utils.http_get(url, params)

		req = RedirectFollower.new ("#{url}?#{params.to_query}")
		res = req.resolve

		{
			:status => res.status,
			:body => res.body
		}
	end


	def Utils.handle_error(res, prepend)
		if (res[:status] != "200")
			begin
				result = JSON.parse(res[:body]);
				puts "#{prepend}: #{result['reason']}"
			rescue
				puts "#{prepend}: #{res[:body]}"
			end
			
			exit!
		end
	end


end
end
