require 'openssl'
require 'json'

module Mocloud
module Utils

	class Credentials

		def initialize
			@credentials_directory = "#{File.expand_path('~')}/.mobingi"
		end

		def write_credentials(creds)
			unless File.directory?(@credentials_directory)
				FileUtils.mkdir_p(@credentials_directory)
			end
			File.write("#{@credentials_directory}/credentials", creds.to_json)

		end

		def read_credentials()
			unless File.directory?(@credentials_directory)
				puts "You have not logged in yet. Please type 'mocloud login' to login"
				exit!
			end
			text = File.read("#{@credentials_directory}/credentials")

			JSON.parse(text)
		end

		def make_token(time)
			creds = read_credentials()

			key = "#{creds['uid']}#{time}"
			signature = "#{creds['token']}"

			OpenSSL::HMAC.hexdigest('sha256', signature, key)
		end
	end
	
end
end
