
module Mocloud
module Utils

	class RedirectFollower
	  class TooManyRedirects < StandardError; end

	  attr_accessor :url, :body, :status, :redirect_limit, :response

	  def initialize(url, limit=5)
	    @url, @redirect_limit = url, limit
	  end

	  def resolve
	    raise TooManyRedirects if redirect_limit < 0

		uri = URI.parse(self.url)

		http = Net::HTTP.new(uri.host, uri.port)
		http.use_ssl = true if uri.scheme == "https"  # enable SSL/TLS
		http.start do
			http.request_get("#{uri.path}?#{uri.query}") do |res|
				self.response = res
			end
		end

	    if response.kind_of?(Net::HTTPRedirection)      
	      self.url = redirect_url
	      self.redirect_limit -= 1

	      resolve
	    end

	    self.body = response.body
	    self.status = response.code
	    self
	  end

	  def redirect_url
	    if response['location'].nil?
	      response.body.match(/<a href=\"([^>]+)\">/i)[1]
	    else
	      response['location']
	    end
	  end
	end

end
end
